import type { AlgoliaSearchOptions } from './bundle.types.js';
export { Hit } from './index.types.js';
export type SearchOptions = Pick<AlgoliaSearchOptions, 'query' | 'attributesToRetrieve' | 'facetFilters' | 'numericFilters' | 'maxValuesPerFacet' | 'sortFacetValuesBy' | 'attributesToHighlight' | 'highlightPreTag' | 'highlightPostTag' | 'page' | 'hitsPerPage' | 'offset' | 'length' | 'maxFacetHits'> & {
    facets?: AlgoliaSearchOptions['facets'] | string;
    facetQuery?: string;
};
export type ClientValidation = {
    validAttributesToRetrieve?: string[];
    validFacetFilters?: string[];
    validAttributesToHighlight?: string[];
    validHighlightPostTags?: string[];
    validHighlightPreTags?: string[];
    maxPage?: number;
    maxHitsPerPage?: number;
    maxOffset?: number;
    maxLength?: number;
    maxHitsTotal?: number;
};
export type Request = {
    params: SearchOptions;
    indexName: string;
};
