import type { Client } from 'pg';
import type { Settings } from '../index.types.js';
interface Props {
    client: Client;
    table: string;
    attributesForFaceting: Required<Settings>['attributesForFaceting'];
    numericAttributesForFiltering: Required<Settings>['numericAttributesForFiltering'];
}
type Entries<T> = {
    [K in keyof T]: [K, T[K]];
}[keyof T][];
type NewEntries = Entries<Pick<Required<Settings>, 'attributesForFaceting' | 'numericAttributesForFiltering'>>;
type Return = {
    new: NewEntries;
} | null;
/**
 * A database query to get all the text or number columns
 */
export declare const getAttributes: ({ table, client, attributesForFaceting, numericAttributesForFiltering, }: Props) => Promise<Return>;
export {};
