import type { Props, GetFiltersReturn, NumericFilter } from './filters.types.js';
/**
 * This is how the facetFilters string is formatted
 * https://www.algolia.com/doc/api-reference/api-parameters/facetFilters/
 * Both the <DynamicWidgets> and <RefinementList> components make request with this format
 */
export declare const getFilters: ({ facetFilters, numericFilters: numericFiltersMaybeString, numericAttributesForFiltering, }: Props) => GetFiltersReturn;
export declare const destructureNumericFilter: (numericFilter: string) => NumericFilter;
/**
 * sortRanges
 * It can take an array od destructured numeric filters and sort them
 * Sorting is important so that we can then group them into ranges.
 */
export declare const sortNumericFilters: (a: NumericFilter, b: NumericFilter) => 0 | 1 | -1;
